% Example rendering a material from UTIA BRDF databaze using 
% the precomputed lists of direction for optimized surfaces
% J. Filip, 20/2/2017

addpath UTIA_BRDF_database;

% loading surface ---------------------------------
S = load('arrayS2.txt');
% S = load('arrayS3.txt');
S(S<0) = 0; % taking care of negative values of elevation angles

% loading UTIA BRDF -------------------------------
fileName = 'm010_fabric002';
if(1)
    % loading BRDF from .mat file
    load(sprintf('%s.mat',fileName),'BRDF');
else
    % loading BRDF from .bin file
    fid = fopen(sprintf('%s.bin',fileName), 'r');
    B = fread(fid, 'double');
    fclose(fid);
    
    ni = 288;
    nv = 288;
    BRDF = reshape(B,ni,nv,3);
end

% evaluate BRDF at individual pixels --------------
RGB = lookup_brdf_val(BRDF, S(:,5), S(:,6), S(:,3), S(:,4));

% visualizing surface -------------------------------
nr = 480;
nc = 640;
O = zeros(nr,nc,3);
for j=1:3
    O(:,:,j)= reshape(RGB(:,j),nc,nr)';
end;

figure(1);
imshow(O);
